﻿using System;
using System.Collections.Generic;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading;

namespace SendSMSByATCommand
{
    public class SMSCOMMS
    {
        private SerialPort SMSPort;
        private Thread ReadThread;
        public static bool _ReadPort = false;

        public SMSCOMMS(string COMMPORT)
        {
            SMSPort = new SerialPort();
            SMSPort.PortName = COMMPORT;
            SMSPort.BaudRate = 115200;
            SMSPort.Parity = Parity.None;
            SMSPort.DataBits = 8;
            SMSPort.StopBits = StopBits.One;
            SMSPort.Handshake = Handshake.None;
            SMSPort.DtrEnable = true;
            SMSPort.RtsEnable = true;
            SMSPort.NewLine = System.Environment.NewLine;
            ReadThread = new Thread(ReadPort);
        }

        public bool SendSMS(string CellNumber, string SMSMessage)
        {
            string MyMessage = null;
            if (SMSMessage.Length <= 160)
            {
                MyMessage = SMSMessage;
            }
            else
            {
                MyMessage = SMSMessage.Substring(0, 160);
            }
                
            if (SMSPort.IsOpen == true)
            {
                Console.WriteLine("Sending: "+ "AT+CMGS=" + CellNumber + "\r");
                SMSPort.Write("AT+CMGS=" + CellNumber + (char)(13));
                Thread.Sleep(200);
                Console.WriteLine("Sending: " + MyMessage);
                SMSPort.Write(MyMessage + (char)(26));
            }
            return false;
        }

        private void ReadPort()
        {
            byte[] RXBuffer = new byte[SMSPort.ReadBufferSize + 1];
            string SMSMessage = null;

            while (SMSPort.IsOpen == true)
            {
                if (SMSPort.BytesToRead != 0)
                {
                    SMSMessage = SMSPort.ReadExisting();
                    Console.Write(SMSMessage);
                }
            }

            Console.WriteLine("Exit ReadPort");
        }
               
        public void Open()
        {
            if (SMSPort.IsOpen == false)
            {
                Console.WriteLine("Open port and start read thread");
                SMSPort.Open();
                ReadThread.Start();
            }
            else
            {
                Console.WriteLine("Port is open");
            }
        }

        public void Close()
        {
            if (SMSPort.IsOpen == true)
            {
                SMSPort.Close();
            }
        }
    }
}
